#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <stdlib.h>
#include <math.h>
#include "CenData.h"
#include "MyMath.h"
#include <string.h>

using namespace std;

CenData::CenData() 
{
	mDimension = -1;
}

CenData::~CenData() 
{
}

bool CenData::readData(NumericMatrix SurvD)
{
	double max_value = -1.0;
	if(SurvD.nrow()<1||SurvD.ncol()%2==1||SurvD.ncol()<1){
		return false;
	}
	mDimension = SurvD.ncol()/2;
	// fill data
	for(int ii=0; ii<SurvD.nrow(); ii++){
		for( int i=0 ; i<(SurvD.ncol()/2) ; i++ ) {
			cendata_t cendata;
			cendata.x = ROUND(SurvD(ii,2*i));
			cendata.e = SurvD(ii,2*i+1);
			if( cendata.e != 0 ) cendata.e = 1;
			mData[i].push_back(cendata);
			if( cendata.x > max_value ) max_value = cendata.x;
		}
	}


	// set psuedo infinity
	pINF = round( 10.0 * max_value );

	// cout << "read " << nline << " samples from the file in " << mDimension << " dimension." << endl;

	return true;
}

bool CenData::writeDataToFile(char *filename) 
{
	ofstream outfile(filename);
	if( !outfile.is_open() ) {
		cerr << "cannot write file: " << filename << endl;
		return false;
	}

	for( unsigned int i=0 ; i<mData[0].size() ; i++ ) {
		for( int j=0 ; j<mDimension ; j++ ) {
			outfile << mData[j][i].x;
			if( mData[j][i].e == 0 ) outfile << "+";
			if( j != mDimension-1 )	outfile << "\t";
		}
		outfile << endl;
	}

	outfile.close();

	return true;
}

void CenData::print_Data()
{
	for(unsigned int i=0; i<mData[0].size(); i++){
		for(int j=0; j<mDimension; j++){
			cout<<mData[j][i].x<<" "<<mData[j][i].e<<" ";
		}
		cout<<endl;
	}
	cout<<"Censored Data : "<<mData[0].size()<<"x"<<mDimension*2<<" Matrix."<<endl;
}
